
void _efl_io_model_children_filter_set(Eo *obj, Efl_Io_Model_Data *pd, void *filter_data, EflIoFilter filter, Eina_Free_Cb filter_free_cb);

EIO_API EIO_API_WEAK EFL_VOID_FUNC_BODYV(efl_io_model_children_filter_set, EFL_FUNC_CALL(filter_data, filter, filter_free_cb), void *filter_data, EflIoFilter filter, Eina_Free_Cb filter_free_cb);

void _efl_io_model_path_set(Eo *obj, Efl_Io_Model_Data *pd, const char *path);


static Eina_Error
__eolian_efl_io_model_path_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   const char *cval;
   if (!eina_value_string_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_io_model_path_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EIO_API EIO_API_WEAK EFL_VOID_FUNC_BODYV(efl_io_model_path_set, EFL_FUNC_CALL(path), const char *path);

const char *_efl_io_model_path_get(const Eo *obj, Efl_Io_Model_Data *pd);


static Eina_Value
__eolian_efl_io_model_path_get_reflect(const Eo *obj)
{
   const char *val = efl_io_model_path_get(obj);
   return eina_value_string_init(val);
}

EIO_API EIO_API_WEAK EFL_FUNC_BODY_CONST(efl_io_model_path_get, const char *, NULL);

Efl_Object *_efl_io_model_efl_object_finalize(Eo *obj, Efl_Io_Model_Data *pd);


void _efl_io_model_efl_object_invalidate(Eo *obj, Efl_Io_Model_Data *pd);


void _efl_io_model_efl_object_destructor(Eo *obj, Efl_Io_Model_Data *pd);


Eina_Iterator *_efl_io_model_efl_model_properties_get(const Eo *obj, Efl_Io_Model_Data *pd);


Eina_Future *_efl_io_model_efl_model_property_set(Eo *obj, Efl_Io_Model_Data *pd, const char *property, Eina_Value *value);


Eina_Value *_efl_io_model_efl_model_property_get(const Eo *obj, Efl_Io_Model_Data *pd, const char *property);


Efl_Object *_efl_io_model_efl_model_child_add(Eo *obj, Efl_Io_Model_Data *pd);


void _efl_io_model_efl_model_child_del(Eo *obj, Efl_Io_Model_Data *pd, Efl_Object *child);


Eina_Future *_efl_io_model_efl_model_children_slice_get(Eo *obj, Efl_Io_Model_Data *pd, unsigned int start, unsigned int count);


unsigned int _efl_io_model_efl_model_children_count_get(const Eo *obj, Efl_Io_Model_Data *pd);


static Eina_Bool
_efl_io_model_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_IO_MODEL_EXTRA_OPS
#define EFL_IO_MODEL_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_io_model_children_filter_set, _efl_io_model_children_filter_set),
      EFL_OBJECT_OP_FUNC(efl_io_model_path_set, _efl_io_model_path_set),
      EFL_OBJECT_OP_FUNC(efl_io_model_path_get, _efl_io_model_path_get),
      EFL_OBJECT_OP_FUNC(efl_finalize, _efl_io_model_efl_object_finalize),
      EFL_OBJECT_OP_FUNC(efl_invalidate, _efl_io_model_efl_object_invalidate),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_io_model_efl_object_destructor),
      EFL_OBJECT_OP_FUNC(efl_model_properties_get, _efl_io_model_efl_model_properties_get),
      EFL_OBJECT_OP_FUNC(efl_model_property_set, _efl_io_model_efl_model_property_set),
      EFL_OBJECT_OP_FUNC(efl_model_property_get, _efl_io_model_efl_model_property_get),
      EFL_OBJECT_OP_FUNC(efl_model_child_add, _efl_io_model_efl_model_child_add),
      EFL_OBJECT_OP_FUNC(efl_model_child_del, _efl_io_model_efl_model_child_del),
      EFL_OBJECT_OP_FUNC(efl_model_children_slice_get, _efl_io_model_efl_model_children_slice_get),
      EFL_OBJECT_OP_FUNC(efl_model_children_count_get, _efl_io_model_efl_model_children_count_get),
      EFL_IO_MODEL_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"path", __eolian_efl_io_model_path_set_reflect, __eolian_efl_io_model_path_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_io_model_class_desc = {
   EO_VERSION,
   "Efl.Io.Model",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Io_Model_Data),
   _efl_io_model_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_io_model_class_get, &_efl_io_model_class_desc, EFL_LOOP_MODEL_CLASS, NULL);
